;; $Id: conz-caz-cdz.tst,v 1.3 2006/11/13 22:08:15 leavens Exp leavens $

(newline)
(displayln "Test case of $Date: 2006/11/13 22:08:15 $")
(newline)

(run-regression-tests-equal?
 `(
   ( (run "let lz = conz(random(1000), 0)
           in let u = caz(lz)
              in -(caz(lz),u)")
     ==> 0 )
   ( (run "let lz = conz(random(1000), conz(random(5000), 0))
           in let u = caz(cdz(lz))
              in -(caz(cdz(lz)),u)")
     ==> 0 )
   ( (run "let x = 0
           in let lz = conz(set x = 2, 3)
              in x")
     ==> 0 )
   ( (run "let x = 0
           in let lz = conz(1, set x = 2)
              in x")
     ==> 0 )
   ( (run "letrec onez() = conz(1, (onez))
           in let ones = (onez)
              in caz(ones)")
     ==> 1 )
   ( (run "letrec twoz() = conz(2, (twoz))
           in let twos = (twoz)
              in caz(cdz(twos))")
     ==> 2 )
   ( (run "letrec threez() = conz(3, conz(3, (threez)))
           in let threes = (threez)
              in caz(cdz(cdz(threes)))")
     ==> 3 )
   ( (run "letrec onez() = conz(1, (onez))
                  addlizts(x, y) = conz(+(caz(x), caz(y)),
                                        (addlizts cdz(x) cdz(y)))
           in let twos = (addlizts (onez) (onez))
              in caz(cdz(twos))")
     ==> 2 )
   ( (run "letrec fibgen(a, b) = conz(a, (fibgen b +(a,b)))
           in let fibs = (fibgen 0 1)
              in letrec nth(lz, n) = if zero?(n) then caz(lz)
                                              else (nth cdz(lz) sub1(n))
                 in (nth fibs 10)")
     ==> 55 )
   ( (run "random(1)")
     ==> 0 )
   )
 )
