// $Id: BinaryTree.h,v 1.3 2006/10/10 12:37:30 leavens Exp leavens $
#include <iostream>
#include <stdlib.h>

class BinaryTree {
 public:
  virtual bool isLeaf() = 0;
    //@ public invariant: !isLeaf() ==> this instanceof Interior;

  virtual int leafSum() = 0;
};

class Leaf : public BinaryTree {
 private:
  int num;

 public:
  bool isLeaf();
  virtual int number();
  Leaf(int n);

  virtual int leafSum();
};

class Interior : public BinaryTree {
 private:
  char* sym;
  BinaryTree* left; BinaryTree *right;

  //@ private invariant: sym != NULL && left != NULL && right != NULL;

 public:
  bool isLeaf();
  virtual BinaryTree* left_tree();
  virtual BinaryTree* right_tree();
  virtual char* symbol();
  virtual int leafSum();

  //@ requires: l != NULL && s != NULL && r != NULL;
  Interior(BinaryTree* l, char* s, BinaryTree* r);
};
